//==== Mini5xx ģ ================================================================= 
// : ʱ, SysTick, UART0, GPIO, EINT0
//  NuTiny_LB_Mini51 ϲLED˸, KEY, LEDUART0ַ
// Copyright reserved by Nuvoton (SH) Ltd.  2013/02/05
//=======================================================================================

#include "Mini5xxBN.h"	
#include "DataFlash.h"

void     CLK_SysTick_Init(void)	;
void     GPIO_Init(void) ;
void     UART0_Init(uint32_t Baud) ;
uint8_t* Tx0FillFiFo(uint8_t*pStr, uint32_t Cnt) ;
uint32_t Tim ; 


/*-------------------------------------------------------------------------------------*/
/* MAIN function                                                                                           */
/*-------------------------------------------------------------------------------------*/
int main(void)
{
  uint32_t Time ;

  CLK_SysTick_Init() ;							           //ʱ
  UART0_Init(115200) ;                                     //øIP
  GPIO_Init() ;                                            //GPIO
  Tx0FillFiFo("\r\nUART0 Ok\r\n",12) ; 
                                               
  FMC_EraseSection(0x3F00) ;                   //0x3E00~0x3FFF
  FMC_WriteWord(0x3F10, 0x123456) ;            //дһ
                                               //ģʽ,ԿMemoryݸı
  do{ 
    GPIO_36 = 1 ;
    Time = SysTick->VAL ;
    while(((Time - SysTick->VAL)&0xFFFFFF) < 950*11000) ;  //ȴ950ms

    GPIO_36 = 0 ;
    Time = SysTick->VAL ;
    while(((Time - SysTick->VAL)&0xFFFFFF) < 50*11000) ;   //ȴ50ms
    
  }while(1) ;
}

//// ʱ ///////////////////////////////////////////////////////////////////////////
void CLK_SysTick_Init(void)					   //ϵĬHCLK=22.1184M,SysTick=HCLK/2
{
  UNLOCKREG();
    CLK->CLKDIV  = ADC_CLK_DIV_8bit(4);                    //ADC ԼΪ150 Ksps
    CLK->CLKSEL0 = CLKS0_HCLK_22M_ | CLKS0_TICK_HCLK_DIV2_ ;  

    CLK->CLKSEL1 = CLKS1_PWM01_HCLK | CLKS1_PWM23_HCLK | CLKS1_TMR0_HCLK  
	               | CLKS1_ADC_22M | CLKS1_UART_22M | CLKS1_WDT_HCLK2048_ ;      

    CLK->CLKSEL2 = CLKS2_PWM45_HCLK | CLKS2_FDIV_HCLK ;              
    CLK->APBCLK  = CLK_ADC_EN | CLK_UART_EN | CLK_TMR0_EN ;  
  LOCKREG();

  SysTick->VAL   = 0 ;			                           //ǰֵ,һʱ䲻׼
  SysTick->LOAD  = 0xFFFFFF;                               //ʱԼ1.525,CLK=22Mhz/2
  SCB->SHP[1]    = 0xBFFFFFFF ;                            //SysTickжȼ2 
  SysTick->CTRL  = 0x00000003 ;                            //ж,ʹsysTick
}

//// GPIOú ///////////////////////////////////////////////////////////////////////
void GPIO_Init(void)					        
{ 
  GPIO0->DOUT = 0xFF ;    				                   //GPIOֵ
  GPIO0->PMD  = Px7_QB | Px6_QB | Px5_QB | Px4_OUT ;       //ϵȫģʽ
  GCR->P0_MFP = 0x0303 ;                                   //Tx,Rx 

  GPIO1->DOUT = 0xFF ;    				                   
  GPIO1->PMD  = Px5_OUT | Px4_OUT | Px3_OUT | Px2_OUT | Px0_OUT ;      
  GCR->P1_MFP = 0x0000 ;                                  

  GPIO2->DOUT = 0xFF ;    				                   
  GPIO2->PMD  = Px6_OUT | Px5_OUT | Px4_OUT | Px3_OUT | Px2_OUT ;          
  GCR->P2_MFP = 0x0000 ;                                  

  GPIO3->DOUT = 0xFF ;                                              
  GPIO3->PMD  = Px6_OUT | Px5_OUT | Px4_OUT| Px2_QB | Px1_OUT | Px0_OUT ; 	
  GCR->P3_MFP = 0x0000 ;                                   //P3.2,INT0 ׼˫   
														  
  GPIO4->DOUT = 0xFF ;    				                 
  GPIO4->PMD  = Px7_QB | Px6_QB ;      
  GCR->P4_MFP = 0x0000 ;                                   //P4óGPIOͲܵ

  GPIO5->DOUT = 0xFF ;
  GPIO5->PMD  = Px5_OUT | Px4_OUT | Px3_OUT| Px2_OUT | Px1_OUT | Px0_OUT ;			    
  GCR->P5_MFP = 0x0000 ;				 					 

  GPIO3->ISR  = 0xFF ;                                     //GPIO0жϱ־
  GPIO3->IMD  = 0x00 ;                                     //0Ϊжģʽ 
  GPIO3->IER  = 0x00700074 ;                               //λ0~7жʹ,16~23ʹ
  GPIO3->DBEN = 0x74 ;                                     //Ϊ1ʹ˷

  GPIODBNCE->CON = 0x26	;					               //64HCLK
  NVIC_SetPriority(EINT0_IRQn, 2);                         //жȼΪ2
  NVIC->ISER[0] = 1<<EINT0_IRQn ;						   //ʹNVICж 
}

////UART0 Initial ///////////////////////////////////////////////////////////////////////
void UART0_Init(uint32_t Baud)                 
{
  UART0->FUN_SEL = 0  ;                                    //UART mode
  UART0->LCR     = 0x0007 ;                                //8bit, 1-stop, no parity
  UART0->BAUD    = 0x30000000 + 22118400/Baud - 2 ;        //UATR_CLK has been selected 22M
  UART0->FCR     = 0x00020020 ;                            //RTS trigger:8, FIFO trigger:8 BYTE
  UART0->IER     = 0 ;                                   
}

//// ѷFiFo /////////////////////////////////////////////////////////////////////
// β :  *pStr, ַָ
//          Cnt , ַ
//  :   pStr, ʣַַ
//          0   ,  ַ
// ˵ : UART064ֽFIFO, UART1,UART216ֽFIFO
/////////////////////////////////////////////////////////////////////////////////////////
uint8_t* Tx0FillFiFo(uint8_t*pStr, uint32_t Cnt)
{
  if(Cnt){                                                 //ַҪ
    do{
      if( UART0->FSR & TX_FIFO_FULL ) break ;              //FiFo˾˳ѭ        
      UART0->THR = *pStr++ ;                               //FiFoһַ
    }while(--Cnt) ;                                        //ֱַ
  }
  if(Cnt) return  pStr ; 
  else    return  0    ;                               
}

//// INT0жϷ ///////////////////////////////////////////////////////////////////
void EINT0_IRQHandler()
{
  Tx0FillFiFo("\n     P32_INT0\n",15) ; 
  GPIO_31   ^= 1 ;                                         //LED˸
  GPIO3->ISR = ~0 ;                                        //жϱ־
}

// ĶʱжϷ, жжϱ־ /////////////////////////////////////////
void SysTick_Handler(void)
{ 
  Tx0FillFiFo("\nSysTick",8) ;                             //ڴӡ
  GPIO_26 ^= 1 ;                                           //LED˸
}

//// λִд˺,ٰȫֱ,֮ main() ////////////////////////////
void SystemInit(void)	                         
{
}
